import { type Opt, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class IcrHomeworkquestion {
  [PrimaryKeyProp]?: 'Id';
  Id!: bigint;
  HomeworkId!: bigint;
  BookId!: bigint;
  PageId!: bigint;
  QuestionId!: bigint;
  QuestionNo?: string;
  Score!: number;
  Revision!: number;
  CreatedBy?: bigint;
  CreatedTime!: Date;
  UpdatedBy?: bigint;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
  QuestionGroupId!: bigint & Opt;
}

export const IcrHomeworkquestionSchema = defineEntity({
  class: IcrHomeworkquestion,
  comment: '作业',
  properties: {
    Id: p.bigint().primary().name('Id').unsigned(false).autoincrement(false).comment('主键Id'),
    HomeworkId: p.bigint().name('HomeworkId').comment('作业Id').index('idx_ICR_HomeworkQuestion_01'),
    BookId: p.bigint().name('BookId').comment('书Id').index('idx_ICR_HomeworkQuestion_02'),
    PageId: p.bigint().name('PageId').comment('页Id').index('idx_ICR_HomeworkQuestion_03'),
    QuestionId: p.bigint().name('QuestionId').comment('问题Id').index('idx_ICR_HomeworkQuestion_04'),
    QuestionNo: p.string().name('QuestionNo').nullable().comment('题号'),
    Score: p.float().name('Score').comment('问题分数'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
    QuestionGroupId: p.bigint().name('QuestionGroupId').comment('问题组Id').defaultRaw(`0`),
  },
});
